//===========================================================================
//  EditorUnit.cpp
//
//  VitualTreeView Ʈ  in-place  ҽ.
//
//  α׷ Form ϳ   VirtualTreeView    ְ,
//   ΰ    Ƿ,   ÿ ʿ ⺻ Ÿ
//  EditorUnit.h   TPropertyData Ÿ ϰ,
//    VirtualTreeViw   Ÿ  TPropertyData  
//    ü ؼ ϸ ˴ϴ.
//
//  Create :
//    2004-06-12 by Roland Beduerftig : Create    IVTEditLink demo for BCB 5
//
//  Update :
//    2005-04-05 by ByoungJun Shin  :  Editor  и.
//    2005-04-13 by ByoungJun Shin  :  in-place Editro ũ⸦ ÷ ũ⿡ µ 
//    2005-04-15 by ByoungJun Shin  :  TPropertyData  Node Ÿ  ʵ 
//    2005-05-02 by ByoungJun Shin  :   Key Donw ߻Ҷ ״  
//    2005-06-23 by ByoungJun Shin  :  in-place Editor ũ⸦ ÷ġ ٸ ũ⿡ µ 
//                                     EditWindowProc Լ  
//    2005-06-24 by ByoungJun Shin  :  in-place Editor  ptCombo  ϵ 
//===========================================================================

//---------------------------------------------------------------------------
#include <ComCtrls.hpp>
#pragma hdrstop

#include "EditorUnit.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)

bool __fastcall TPropertyEditLink::Init(TVirtualStringTree* Tree, TVirtualNode* Node, int Column, TPropertyData* Data, TStringList *combolist)
{
	FRefCount = 0;
	FTree = Tree;
	FNode = Node;
	FColumn = Column;
	FData = Data;
	FStopping = false;
	
	switch (FData->PropertyTyp)
	{
		case ptNoOne:
			FEdit = NULL;
			break;

		case ptEdit:
			FEdit = new TEdit((void*)NULL);
			FEdit->Parent = Tree;
			break;
		case ptCombo:
			FEdit = new TComboBox((void*)NULL);
			FEdit->Parent = Tree;
			if (FEdit && combolist)
			{
				((TComboBox*)FEdit)->Items->AddStrings(combolist);
				//for (int i = 0 ; i < combolist->Count ; i++)
				//    ((TComboBox*)FEdit)->Items->Add(combolist->Values[i]);
			}
			break;
		case ptDate:
			FEdit = new TDateTimePicker((void*)NULL);
			FEdit->Parent = Tree;
			break;
		default:
			FEdit = NULL;
	}
	return false;
}
//---------------------------------------------------------------------------
void __fastcall TPropertyEditLink::Uninit(void)
{
    if (FEdit)
    {
        delete FEdit;
        FEdit = NULL;
    }
}
//---------------------------------------------------------------------------
__fastcall TPropertyEditLink::TPropertyEditLink(TVirtualStringTree* Tree, TVirtualNode* Node, int Column, TPropertyData* Data)
{
    Init(Tree, Node, Column, Data, NULL);
}
//---------------------------------------------------------------------------
__fastcall TPropertyEditLink::TPropertyEditLink(TVirtualStringTree* Tree, TVirtualNode* Node, int Column, TPropertyData* Data, TStringList *combolist)
{
    Init(Tree, Node, Column, Data, combolist);
}
//---------------------------------------------------------------------------
__fastcall TPropertyEditLink::~TPropertyEditLink(void)
{
    Uninit();
    //  Release() will delete myself if counter == 0 !!!!!
}
//---------------------------------------------------------------------------
void __fastcall TPropertyEditLink::EditWindowProc(TMessage &Message)
{
	// here we can capture some messages for keeping track of focus changes
	switch (Message.Msg)
	{
		case WM_KILLFOCUS:
			//EndEdit();
			if ((int)FTree->Handle != Message.WParam)
				SetFocus((HWND)Message.WParam);
			break;
		default:
			FOldEditProc(Message);
	}
}
//---------------------------------------------------------------------------
void __fastcall TPropertyEditLink::EditKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	//  als Key hat man hier: VK_HOME VK_END VK_UP VK_DOWN VK_PRIOR VK_NEXT VK_ESCAPE VK_RETURN
	bool CanAdvance;
	TShiftState Empty;
	bool Handled;
	TVirtualNode*  NewFocusedNode;       // The node being edited.

	CanAdvance = true;
	Handled = false;
	switch (Key)
	{
		case VK_ESCAPE:
			FTree->CancelEditNode();
			Key = 0;
			break;

		/*
		case VK_RETURN:
			EndEdit();
			Key = 0;
			break;
		*/

		case VK_PRIOR:
		case VK_UP:
		case VK_NEXT:
		case VK_DOWN:
			if (FEdit->ClassNameIs("TComboBox"))
			{
				Empty.Clear();
				CanAdvance = (Shift == Empty);
				Handled = !(((TComboBox*)FEdit)->DroppedDown);
				CanAdvance = CanAdvance && (!((TComboBox*)FEdit)->DroppedDown);
			}
			else if (FEdit->ClassNameIs("TDateTimePicker"))
			{
				Empty.Clear();
				CanAdvance = (Shift == Empty);
				CanAdvance =  CanAdvance &&  (! ((TDateTimePicker*)FEdit)->DroppedDown);
			}
			else
				CanAdvance = (Shift.Contains(ssShift) || Shift.Contains(ssCtrl));

			if (CanAdvance)
			{
				if ( (Key ==  VK_PRIOR) || (Key == VK_UP) )
					NewFocusedNode = FTree->GetPreviousVisible(FTree->FocusedNode);
				else
					NewFocusedNode = FTree->GetNextVisible(FTree->FocusedNode);

				if (NewFocusedNode)
				{
					  EndEdit();
					  FTree->Selected[NewFocusedNode] = true;
					  FTree->SetFocus();
				}

				Key = 0;
			}
			//else
			//{
				// Forward the keypress to the tree. It will asynchronously change the focused node.
			//    PostMessage(FTree->Handle, WM_KEYDOWN, Key, 0);

			//}
			break;
	}

}
//---------------------------------------------------------------------------
bool __stdcall TPropertyEditLink::BeginEdit(void)
{
	bool Result = !FStopping;
	if (Result && (FEdit != NULL))
	{
		FEdit->Show();
		FEdit->SetFocus();
		FOldEditProc = FEdit->WindowProc;
		FEdit->WindowProc = &EditWindowProc;
	}
	return(Result);
}
//---------------------------------------------------------------------------
bool __stdcall TPropertyEditLink::CancelEdit(void)
{
    bool Result = FStopping;
    if (!FStopping)
    {
        FStopping = true;
        if (FEdit != NULL)
        {
            FEdit->WindowProc = FOldEditProc;
            FEdit->Hide();
        }
        FTree->CancelEditNode();
    }
    return(Result);
}
//---------------------------------------------------------------------------
bool __stdcall TPropertyEditLink::EndEdit(void)
{
    char  Buffer[1024];
	WideString S;  																// TVirtualNode* Node;
	int index;
   //  bool Result = FStopping;
	if (!FStopping)
    {
  		FStopping = true;
		FEdit->WindowProc = FOldEditProc;                             			// restore the edit's window proc
		switch (FData->PropertyTyp)
        {
			case ptNoOne:
                FData->Changed = false;
				break;

            case ptEdit:
                GetWindowText(FEdit->Handle, Buffer, 1024);
                S = Buffer;
                if (S != FData->Value)
                {
                    FData->Value = S;
                    FData->Changed = true;
                    // by bolero
                    //FTree->InvalidateNode(FData->Node);
                    FTree->InvalidateNode(FNode);
                }
                break;
            case ptCombo:   /* must in Orginal the code working with ItemIndex */
                index = ((TComboBox*)FEdit)->ItemIndex;
                S = ((TComboBox*)FEdit)->Items->Strings[index];
                if (S != FData->Value)
                {
                    FData->Value = S;
                    FData->Changed = true;
                }
           		break;
            case ptDate:
		   //     TDate tD = ((TDateTimePicker*)FEdit)->Date;
                S = DateToStr(((TDateTimePicker*)FEdit)->Date);
                if (S != FData->Value)
                {
                    FData->Value = S;
                    FData->Changed = true;
                    // by bolero
                    //FTree->InvalidateNode(FData->Node);
                    FTree->InvalidateNode(FNode);
                }
                break;
   	    }
  		FEdit->Hide();
  		FTree->EndEditNode();
    	//  if (FData->Changed) FTree.DoNewText(FNode, FColumn, FCaption);
  	}
    //  return(Result);
    //  with version 2.5.40 return true,   when you are ready
    //                      return false,  when you detect an error and want editing again
    return(true);
}
//---------------------------------------------------------------------------
bool __stdcall TPropertyEditLink::PrepareEdit(TBaseVirtualTree* Tree, PVirtualNode Node, TColumnIndex Column)
{
    int iP;
    AnsiString Strg;
    bool Result = false;
    WideString FCaption;

    if (!Node)
		return(Result);                                        					//  only for safety the program !
    if (FEdit == NULL)
        return(Result);
	if (FData == NULL)
		return(Result);
		
    //FTree = (TVirtualStringTree*)Tree;
    //FNode = Node;
    //FColumn = Column;
    //FData = (TPropertyData*)FTree->GetNodeData(FNode);
	//FEdit->Parent = FTree;

	switch (FData->PropertyTyp)
	{
        case ptNoOne:
            break;
        case ptEdit:
            ((TEdit*)FEdit)->Visible = false;
            ((TEdit*)FEdit)->Text = FData->Value;
            ((TEdit*)FEdit)->OnKeyDown = &EditKeyDown;
            Result = true;
            break;
        case ptCombo:
            ((TComboBox*)FEdit)->Visible = false;

            iP = ((TComboBox*)FEdit)->Items->IndexOf(FData->Value);
            if (iP < 0)
                iP = ((TComboBox*)FEdit)->Items->Add(FData->Value);

            ((TComboBox*)FEdit)->ItemIndex = iP;
            ((TComboBox*)FEdit)->Style = Stdctrls::csDropDownList;
            ((TComboBox*)FEdit)->OnKeyDown = &EditKeyDown;
            Result = true;
            break;
        case ptDate:
            ((TDateTimePicker*)FEdit)->Visible = false;
            ((TDateTimePicker*)FEdit)->CalColors->MonthBackColor = clWindow;
            ((TDateTimePicker*)FEdit)->CalColors->TextColor = clBlack;
            ((TDateTimePicker*)FEdit)->CalColors->TitleBackColor = clBtnShadow;
            ((TDateTimePicker*)FEdit)->CalColors->TitleTextColor = clBlack;
            ((TDateTimePicker*)FEdit)->CalColors->TrailingTextColor = clBtnFace;
            ((TDateTimePicker*)FEdit)->Date = StrToDate(FData->Value);
            ((TDateTimePicker*)FEdit)->OnKeyDown = &EditKeyDown;
            Result = true;
            break;
    }
    return(Result);
}
//---------------------------------------------------------------------------
Types::TRect __stdcall TPropertyEditLink::GetBounds(void)
{
    TRect R;
    if (FEdit != NULL)
        R = FEdit->BoundsRect;
    else
        memset(&R, 0, sizeof(TRect));
        
    return(R);
}
//---------------------------------------------------------------------------
void __stdcall TPropertyEditLink::ProcessMessage(Messages::TMessage &Message)
{
    FEdit->WindowProc(Message);
}
//---------------------------------------------------------------------------
void __stdcall TPropertyEditLink::SetBounds(const Types::TRect R)
{
    TRect eR;  
    if (FEdit != NULL)
    {
       eR.Left = R.Left;
       eR.Top = R.Top;
       eR.Bottom = R.Bottom;
       eR.Right = R.Left + FTree->Header->Columns->Items[FColumn]->Width;
       // by bolero
       if (FColumn == 0)
       {
            eR.Right -= FTree->Indent;
       }
    }
    else
        memset(&eR, 0, sizeof(TRect));

    if (!FStopping && (FEdit != NULL))
		FEdit->BoundsRect = eR;
}
//---------------------------------------------------------------------------

ULONG __stdcall TPropertyEditLink::AddRef()                                     //  Implement IUnknown interface
{
	return InterlockedIncrement((LPLONG)&FRefCount);                            //  thread safe increment
}
//---------------------------------------------------------------------------
ULONG __stdcall TPropertyEditLink::Release()                                    //  Implement IUnknown interface
{
	InterlockedDecrement((LPLONG)&FRefCount);                                   //  thread safe decrement
	if (FRefCount == 0) {                                                       //  if last user then
		delete this;                                                            //    delete myself
		return 0;                                                               //    => 0 !
	}
	return FRefCount;                                                           //  return internal counter
}
//---------------------------------------------------------------------------
HResult  __stdcall TPropertyEditLink::QueryInterface(const GUID& IID, void**ppv) {
	if (IID == __uuidof(IUnknown))                                              //  IUnknown as basic interface
   	*ppv = (IUnknown*)this;
	else if (IID == __uuidof(IVTEditLink))                                      //  i am self
		*ppv = (IVTEditLink*)this;
	else {
		*ppv = NULL;                                                            //  unknowm interface
		return E_NOINTERFACE;
	}
	((IUnknown*)(*ppv))->AddRef();                                              //  increment if used
	return S_OK;                                                                //  Ok !
}
//===========================================================================
