
//---------------------------------------------------------------------------
//  Demoprogram for own editor under VT 2.4x
//
//  This demoprogram is based on VirtualTrees Library from Mike Lischke.
//  Please read the copyright info in VirtualTrees.pas
//
//  In this place many thanks to Alexander Egorushkin for the
//  very very important information to implement an interface to use
//  own editor under BCB5.
//
//  Copyright (c) 4.2001  information about               Alexander Egorushkin
//                        "interface" and how to use it
//                        this demoprogram                Roland Beduerftig
//                        EMail:                          Beduerftig@SoftwareCreation.de
//
//  Free: You may use this code in every way you find it useful or fun.
//
//  Credits for their valuable assistance and code donations go to:
//    see VirtualTrees.pas
//---------------------------------------------------------------------------
//===========================================================================
//  EditorUnit.h
//
//  VitualTreeView Ʈ  in-place  ҽ.
//
//  α׷ Form ϳ   VirtualTreeView    ְ,
//   ΰ    Ƿ,   ÿ ʿ ⺻ Ÿ
//  EditorUnit.h   TPropertyData Ÿ ϰ,
//    VirtualTreeViw   Ÿ  TPropertyData  
//    ü ؼ ϸ ˴ϴ.
//
//  Update :
//    cpp  
//
//===========================================================================

//---------------------------------------------------------------------------

#ifndef EditorUnitH
#define EditorUnitH

#include <vcl.h>
#include "VirtualTrees.hpp"

typedef enum {
   ptNoOne,                                                                      //  not support inline-editor
   ptEdit,
   ptCombo,
   ptDate
} TPropertyTyp;

//   ..
typedef struct
{
   TPropertyTyp    PropertyTyp;                                                 // editory type
   WideString      Value;                                                       // data value
   bool            Changed;                                                     //  
} TPropertyData, *lpPropertyData;

                                                                                // Our own edit link to implement several different node editors.
class TPropertyEditLink : public IVTEditLink
{
  private:
	ULONG FRefCount;                                                            // used by our own implementation of the interface

	TVirtualStringTree * FTree;                                                 // A back reference to the tree calling.
	TVirtualNode*  FNode;                                                       // The node being edited.
	TPropertyData*      FData;
	TWndMethod          FOldEditProc;                                           //  used to capture some important messages
	TWinControl *FEdit;
    int FColumn;                                                                // The column of the node being edited.
	bool  FStopping;                                                            //  local merker

	bool __fastcall Init(TVirtualStringTree* Tree, TVirtualNode* Node, int Column, TPropertyData* Data, TStringList *combolist);
	void __fastcall Uninit(void);

  protected:
	void __fastcall EditWindowProc(TMessage &Message);
	void __fastcall EditKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);

  public:
	// Combo Box Editing
	__fastcall TPropertyEditLink(TVirtualStringTree* Tree, TVirtualNode* Node, int Column, TPropertyData* Data, TStringList *combolist);
	// Anothser Editing
	__fastcall TPropertyEditLink(TVirtualStringTree* Tree, TVirtualNode* Node, int Column, TPropertyData* Data);
    virtual __fastcall ~TPropertyEditLink(void);

    // IUnknown members
	virtual ULONG   __stdcall AddRef();
	virtual ULONG   __stdcall Release();
	virtual HResult  __stdcall QueryInterface(const GUID& IID, void** ppv);

    virtual bool __stdcall BeginEdit(void);
	virtual bool __stdcall CancelEdit(void);
	virtual bool __stdcall EndEdit(void);
	virtual bool __stdcall PrepareEdit(TBaseVirtualTree* Tree, PVirtualNode Node, TColumnIndex Column);
	virtual Types::TRect __stdcall GetBounds(void);
	virtual void __stdcall ProcessMessage(Messages::TMessage &Message);
	virtual void __stdcall SetBounds(const Types::TRect R);
};


//---------------------------------------------------------------------------
#endif
